%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
% close all;
% clear all;
global time_data;
global series_data;

%% Telecharger vos donnes ici SANS INTERPOLATION

% load('resume_ADCP_total_rotation.mat')
% for i=1:length(ADCP)
%     time_data(i,:)=ADCP(1).date;
%     series_data(i,:)=ADCP(i).u(:,2);
% end
% 
% % % dt=mean(diff(time_data)); % 10 min
% % dt=10/60;

load ('pascal_TS.mat');
for i=1:size(ti,2)
    time_data(i,:)=date;
    series_data(i,:)=ti(:,i);
end


% load('load_donnes_Marel.mat')
% 
% time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
% data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
% time_data(1,:)=time1;time_data(2,:)=time2;time_data(3,:)=time3;time_data(4,:)=time3;
% series_data(1,:)=data1;series_data(2,:)=data2;series_data(3,:)=data3;series_data(4,:)=data4;
% 
% dt=20/60; % toutes les 20 minutes

%% Preparer les donnes: pas d interpolation et pas de NaN, juste les instants auxquels les donnes ont bien ete mesurees

%% EMD 
[imf1,ort1,nbits1] = emd(series_data(1,~isnan(series_data(1,:)))','T',time_data(1,~isnan(series_data(1,:))),'MAXITERATIONS',600);
[imf2,ort2,nbits2] = emd(series_data(2,~isnan(series_data(2,:)))','T',time_data(2,~isnan(series_data(2,:))),'MAXITERATIONS',600);
[imf3,ort3,nbits3] = emd(series_data(3,~isnan(series_data(3,:)))','T',time_data(3,~isnan(series_data(3,:))),'MAXITERATIONS',600);
[imf4,ort4,nbits4] = emd(series_data(4,~isnan(series_data(4,:)))','T',time_data(4,~isnan(series_data(4,:))),'MAXITERATIONS',2000);

%% Calculation of mean instantaneous period of each IMF

meanPeriod(1,1:size(imf1,1)-1)=mean(diff(time_data(1,:)))*(1./meanf(imf1));
meanPeriod(2,1:size(imf2,1)-1)=mean(diff(time_data(2,:)))*(1./meanf(imf2));
meanPeriod(3,1:size(imf3,1)-1)=mean(diff(time_data(3,:)))*(1./meanf(imf3));
meanPeriod(4,1:size(imf4,1)-1)=mean(diff(time_data(4,:)))*(1./meanf(imf4));

%% Choisir les IMFs pour faire la cross-correlation avec TDIC

numberMode=8;% changer cette ligne
if mod(size (imf1,2),2) ==0 
    x1=imf1(numberMode,1:end);
    y1=imf2(numberMode,1:end);
else
    x1=imf1(numberMode,1:end-1);
    y1=imf2(numberMode,1:end-1);
end

% il vaut mieux faire l echantillonnage a ce niveau
% x=x1;
% y=y1;
x=x1(1:10:end);
y=y1(1:10:end);
axeTemps= time_data(1,1:10:end);
%% Methode TDIC
pp=maxlocalperiod(x,y); % local time period provided by the zero?crossing method
ntime=floor(length(x)/1) ; % ntime is the maximum window size
nct=fix(ntime/2); % nct is the maximum size of moving  time window
tic
[c,p,tx,scale]=tdic(x,y,pp,ntime,nct);
% [c,p,tx,scale]=tdic(x,y,pp);
toc
% les outputs :
% c is the correlation matrix
% p is the indicator for student-test
% tx is the time axis
% scale is the time scale

MatrixPlot=c.*p;
% dlmwrite('resultat_TDIC.txt',MatrixPlot,'delimiter',' ','precision','%.4f','newline','pc');
% On recupere 10% de la matrice pour faire le plot
% % % % % j=1;
% % % % % for i=1:size(MatrixPlot,1)
% % % % %     if mod(i,10)==0
% % % % %         B(j,:)=MatrixPlot(i,:);
% % % % %         j=j+1;
% % % % %     end
% % % % % end
% % % % % dlmwrite('B_submatrix_resultat_TDIC.txt',B,'delimiter',' ','precision','%.4f','newline','pc');
% % % % % 
% % % % % L=length(B);

% Si necessaire, on peut encore reduire les echantillons de la matrice
% % % % j=1;
% % % % for i=1:size(B,1)
% % % %     if mod(i,3)==0
% % % %         B2(j,:)=B(i,:);
% % % %         j=j+1;
% % % %     end
% % % % end

% clear MatrixPlot;clear B;
eupsilon =30; % changer ce parametre
scale_=1:30:size(scale,2)-eupsilon;
h=figure
set(gcf,'Visible','off')
% surf(time_data(1:length(MatrixPlot)),scale*mean(diff(time_data(1,:))),MatrixPlot,'edgecolor','none')
% surf(time_data(1:L),scale_*mean(diff(time_data(1,:))),B,'edgecolor','none')
surf(axeTemps,scale*mean(diff(time_data(1,:))),MatrixPlot,'edgecolor','none')
tlabel
axis xy
view(0,90)
colorbar
ylabel ('sliding window (days)')
set(gca,'ticklength',[-0.01,0.025])
set(gca,'FontSize',12)
print -djpeg -zbuffer -r600 TDIC.jpeg