%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
clear all;
close all;
global time1;
global time2;
global time3;
global time4;

global data1;
global data2;
global data3;
global data4;

%% Telecharger vos donnes ici AVEC INTERPOLATION car on va faire des ondelettes

load ('Pascal_TS.mat');
time1=date;
data1=ti(:,1);
time2=date;
data2=ti(:,2);
time3=date;
data3=ti(:,3);
time4=date;
data4=ti(:,4);
seriesname={'Temp1' 'Temp2' 'Temp3' 'Temp4'};

% load('load_donnes_Marel.mat')
% time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
% data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
% 
% seriesname={'Temperature' 'Salinity','Sea level','Turbidity'};

% load('resume_ADCP_total_rotation.mat')
% time_data=ADCP(1).date;
% data1=ADCP(1).u(:,2);
% data2=ADCP(2).u(:,2);
% data3=ADCP(3).u(:,2);
% data4=ADCP(4).u(:,2);
% seriesname={'U(S1)' 'U(S2)' 'U(S3)' 'U(S4)'};

% deltat   =mean(diff(x_data));
deltat   =20/(24*60); % 10 min pour les donnes ile de la Runion et 20 min pour Marel Carnot

%% Preparer les donnes pour CWT, XWT et CWT --> il faut interpoler et avoir un meme axe de temps qui servira pour la cross correlation

time=(time1(1): 10/(60*24):time1(end))'; % meme axe de temps qui servira pour la cross correlation
data1=interp1(time1,data1,time) ;
data2=interp1(time2,data2,time) ;
data3=interp1(time3,data3,time) ;
data4=interp1(time4,data4,time) ;

data1(isnan(data1))=interp1(find(~isnan(data1)), data1(~isnan(data1)), find(isnan(data1)));
data2(isnan(data2))=interp1(find(~isnan(data2)), data2(~isnan(data2)), find(isnan(data2)));
data3(isnan(data3))=interp1(find(~isnan(data3)), data2(~isnan(data3)), find(isnan(data3)));
data4(isnan(data4))=interp1(find(~isnan(data4)), data2(~isnan(data4)), find(isnan(data4)));

%% Preparer pour le calcul des ondelettes
d1=[time,data1];
d2=[time,data2];
d3=[time,data3];
d4=[time,data4];


%% Continuous wavelet transform (CWT)
tlim=[min(d1(1,1),d2(1,1)) max(d1(end,1),d2(end,1))];
superposition =1;
if superposition ==1
    [imf1,ort1,nbits1] = emd(data1(~isnan(data1))','T',time1(~isnan(time1)),'MAXITERATIONS',600);
     meanPeriod1=mean(diff(time1))*(1./meanf(imf1));
end
figure(1)
% subplot(2,2,1);
wt(d1);
title(seriesname{1});
set(gca,'xlim',tlim);
tlabel
xlim([time(1) time(end)])
% Choisir si on superpose les IMFs ou pas
for i=1:length(meanPeriod1)
    hold on
    plot([time(1) time(end)],[log2(meanPeriod1(i)) log2(meanPeriod1(i))],'--bs') 
    text(min(time)+10,log2(meanPeriod1(i)),['T(IMF',num2str(i),')'])
end
tlabel
xlim([time(1) time(end)])
% subplot(2,2,2)
% wt(d2)
% title(seriesname{2})
% set(gca,'xlim',tlim)
% tlabel
% xlim([time(1) time(end)])
% 
% subplot(2,2,3);
% wt(d3);
% title(seriesname{3});
% set(gca,'xlim',tlim);
% tlabel
% xlim([time(1) time(end)])
% 
% subplot(2,2,4)
% wt(d4)
% title(seriesname{4})
% set(gca,'xlim',tlim)
% tlabel
% xlim([time(1) time(end)])

% set(gcf,'renderer','zbuffer');
% print -djpeg -r600 CWT.jpeg

%% Wavelet Coherence (WTC)
% % % % figure
% % % % wtc(d1,d2,'mcc',0) % choisir les series qu on veut
% % % % % wtc(d1,d2)
% % % % title(['WTC: ' seriesname{1} '-' seriesname{2} ] )
% % % % tlabel
% % % % xlim([time(1) time(end)])
% % % % % set(gcf,'renderer','zbuffer');
% % % % % print -djpeg -r600 WTC.jpeg

%% Cross wavelet (XWT)
% % % % figure
% % % % xwt(d3,d4)
% % % % title(['XWT: ' seriesname{3} '-' seriesname{4} ] )
% % % % tlabel
% % % % xlim([time(1) time(end)])
% % % % % set(gcf,'renderer','zbuffer');
% % % % % print -djpeg -r600 XWT.jpeg