%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
clear all;
close all;
global x_data;
global y_data;
global yLabel;
global xLabel;

%% Tlcharger vos donnes ici (remplacer le code pour les 5 lignes suivantes)
load ('Pascal_TS.mat');
x_data=date;
y_data=ti(:,1);
xLabel='{\bf Time (year, month, day, hour)}';
yLabel='{\bf Temperature (C)}';


%% Compute and plot autocorrelation (see MATLAB Recipes for Earth Sciences p.124)

yc= y_data;
% yc= y_data-mean(y_data);
for i = 1 : length(yc) - 2
    r = corrcoef(yc(1:end-i),yc(1+i:end));
    C(i) = r(1,2);
end
figure
plot(C)
xlabel('Delay'), ylabel('Autocorrelation')
grid on


%% To eliminate the long-term trend, we use the function detrend
ydt = detrend(y_data);
figure
plot(x_data,y_data,'b-',x_data,ydt,'r-');
tlabel;
title('Time series before and after detrending')
legend('Before','After');


%What was eliminated ? --> plot the trend
ydt = detrend(y_data);
figure
plotTrend=plot(x_data,y_data-ydt,'--m');
set(plotTrend(1),'LineWidth',2)
grid on;
xlabel(xLabel);
ylabel(yLabel);
title('The trend of the time series','FontWeight','bold');
tlabel;


%% Autocorrelation using xcorr function(Signal Processing Toolbox)
            maxlag = length(y_data);   % set a max lag value here
            [c,lags] = xcorr(detrend(y_data), maxlag, 'biased');
            figure;
            plot(lags,c), xlabel('lags'), ylabel('autocorrelation')
            grid on

            % Test if the autocorrelation function is symmetric or not
            i=1;
            symmetric=1;
            clength=length(c);
            while (symmetric ==1 && i<=(clength-1)/2)
                %pour comparer deux reels A et B avec une precision de n chiffres significatifs : abs(A-B) < 10^-n;
                if( abs(c(i)-c(clength-i+1)) > 10^-10) 
                    symmetric =0;
            %         display(['c(' num2str(i) ')=' num2str(c(i)) ' Different from ' 'c(' num2str(clength-i+1) ')=' num2str(c(clength-i+1))]);
                end
                i=i+1;
            end
            if(symmetric==1)
                display('the autocorrelation function of the detrended time series is symmetric');
            else
                 display('the autocorrelation function of the detrended time series is NOT symmetric');
            end

            % Is the maximum amplitude of the detrended time series autocorrelation function in zero? 
            max_c=max(c);
            testmax=0;
            if(abs(max_c-c((clength+1)/2) )< 10^-10) 
                testmax=1;
                display(['Maximum amplitude for \tau = 0 --> ' num2str(c((clength+1)/2))]);
            end
            
 %% Another method to plot autocorrelation function using
% acf(Spatial Econometrics Toolbox) --> package jplv7.zip to download from
% http://www.spatial-econometrics.com/
            r3=acf(detrend(y_data),length(detrend(y_data))-2,1);
            figure
            plot(r3.ac);
            legend ('R(\tau)');
            title('Autocorrelation Function after detrend (using acf)');
            xlabel('time delay, \tau in seconds');
            grid on
            
 %% Differenciate the time series
yDiff=detrend(diff(y_data));
% Compute and plot autocorrelation after differentiation (see MATLAB Recipes for Earth Sciences p.124)
yDiffc= yDiff;
for i = 1 : length(yDiff) - 2
    rDiff = corrcoef(yDiff(1:end-i),yDiff(1+i:end));
    CDiff(i) = rDiff(1,2);
end
figure
plot(CDiff)
xlabel('Delay');
title('Autocorrelation after differenciation');
grid on