%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
close all;
clear all;
global time_data;
global series_data;
global dt;

%% Telecharger vos donnes ici SANS INTERPOLATION et changer dt !!

% load('resume_ADCP_total_rotation.mat')
% for i=1:length(ADCP)
%     time_data(i,:)=ADCP(1).date;
%     series_data(i,:)=ADCP(i).u(:,2);
% end
% 
% % % dt=mean(diff(time_data)); % 10 min
% % dt=10/60;

load ('pascal_TS.mat');
for i=1:size(ti,2)
    time_data(i,:)=date;
    series_data(i,:)=ti(:,i);
end

dt=10/60; % toutes les 10 minutes


% load('load_donnes_Marel.mat')
% 
% time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
% data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
% time_data(1,:)=time1;time_data(2,:)=time2;time_data(3,:)=time3;time_data(4,:)=time3;
% series_data(1,:)=data1;series_data(2,:)=data2;series_data(3,:)=data3;series_data(4,:)=data4;
% 
% dt=20/60; % toutes les 20 minutes

%% Preparer les donnes: pas d interpolation et pas de NaN, juste les instants auxquels les donnes ont bien ete mesurees

%% EMD 
% for i=1:4
%     [imf,ort,nbits] = emd(series_data(i,:)','T',time_data,'MAXITERATIONS',600);
% %   [imf(i,:),ort(i,:),nbits(i,:)] = emd(series_data(i,:)','T',time_data,'STOP',[0.1,0.5,0.05],'MAXITERATIONS',2000);
% end
[imf1,ort1,nbits1] = emd(series_data(1,~isnan(series_data(1,:)))','T',time_data(1,~isnan(series_data(1,:))),'MAXITERATIONS',600);
[imf2,ort2,nbits2] = emd(series_data(2,~isnan(series_data(2,:)))','T',time_data(2,~isnan(series_data(2,:))),'MAXITERATIONS',600);
[imf3,ort3,nbits3] = emd(series_data(3,~isnan(series_data(3,:)))','T',time_data(3,~isnan(series_data(3,:))),'MAXITERATIONS',600);
[imf4,ort4,nbits4] = emd(series_data(4,~isnan(series_data(4,:)))','T',time_data(4,~isnan(series_data(4,:))),'MAXITERATIONS',1200);


%% Visualisation des IMFs (Patrick Flandrin)
emd_visu(series_data(1,:),time_data(1,:),imf1);
% emd_visu(series_data(2,:),time_data(2,:),imf2);
% emd_visu(series_data(3,:),time_data(3,:),imf3);
% emd_visu(series_data(4,:),time_data(4,:),imf4);

%% Visualisation des IMFs (Dhouha Kbaier)
% Changer les 3 lignes suivantes pour imf, t et y 
imf=imf1;
t=time_data(1,:);
y=series_data(1,:);

n=size(imf,1);
Nbr= ceil(n/2);
if mod(n,2) == 0
   %on ne plot pas la serie d'origine
   origin=0;
else
   %on plot la serie d'origine
    origin=1;
end

figure
compteur=1;
if origin==1
    subplot(Nbr,2,compteur);
    compteur=compteur+1;
    plot(t,y);
    ylabel('Temperature (C)');
    xlim([t(1) t(end)]);
    set(gca,'xTick',[])
end

subplot(Nbr,2,2*Nbr); % le dernier plot doit toujours contenir le residu
plot(t,imf(n,:));  ylabel('Residual (C)'); tlabel;xlim([t(1) t(end)]);

for i=1:n-1
    if (compteur<=Nbr)
        if origin ==0
            subplot(Nbr,2,2*i-1);
        else
           subplot(Nbr,2,2*i+1); 
        end
        compteur=compteur+1;
    else % compteur > Nbr
        if origin ==0
            subplot(Nbr,2,2*i-n);
        else
            subplot(Nbr,2,2*i-(n-1));
        end
        compteur=compteur+1;
    end
    plot(t,imf(i,:));
    ylabel(['IMF',num2str(i),' (C)']);tlabel;xlim([t(1) t(end)]);
    set(gca,'xTick',[])
    
end

for i=1:2*Nbr
    subplot(Nbr,2,i);
    tlabel;xlim([t(1) t(end)]);
end

print -djpeg -r600 Visual_IMF_Dhouha.jpeg
%% Calculation of mean instantaneous period of each IMF
meanPeriod(1,1:size(imf1,1)-1)=dt*(1./meanf(imf1));
meanPeriod(2,1:size(imf2,1)-1)=dt*(1./meanf(imf2));
meanPeriod(3,1:size(imf3,1)-1)=dt*(1./meanf(imf3));
meanPeriod(4,1:size(imf4,1)-1)=dt*(1./meanf(imf4));

%% Plot les residus pour pouvoir changer le parametre MAXITERATIONS
figure
plot(time_data(1,~isnan(series_data(1,:))), imf1(end,:),time_data(2,~isnan(series_data(2,:))), imf2(end,:),time_data(3,~isnan(series_data(3,:))), imf3(end,:),time_data(4,~isnan(series_data(4,:))), imf4(end,:))
% plot(time_data(1,~isnan(series_data(1,:))), imf1(end,:));
tlabel
legend('Res. -1-','Res. -2-','Res. -3-','Res. -4-','location','northWest')

%% Significance des IMFs : les IMFs c'est vraiment du signal ou du bruit ?

% Significance properties of IMF:
% Combine White-Noise confidence Curve and IMF significance. 
% 2 confidence limit 90% and 95% curves are plot as default value. 

imf=imf1;       % changer cette ligne
saveplot=0; 
figure;
signiplotIMF( imf(:,2:end-1), saveplot);

%% Hilbert Spectral Analysis (HSA)

imf=imf1;               % changer cette ligne
time=time_data(1,:);    % changer cette ligne

% Utilisation de la fonction 'hhspectrum' de Patrick Flandrin

Nmodes = size(imf(1:end-1,:),1);
[A,ff,tt] = hhspectrum(imf(1:end-1,:));
% outputs:
%   - A   : instantaneous amplitudes 
%   - ff   : instantaneous frequencies
%   - tt  : truncated time instants

%Calculation of mean instantaneous frequency of each IMF
mnf=ones(1,Nmodes);
f_inst=ff./dt;
for i=1:Nmodes 
    mnf(i)=sum(f_inst(i,:).*(A(i,:)).^2)/norm(A(i,:))^2;
end

%Finding mean frequency
for z=1:size(imf,1)-1
    meanf=sum(norm(A(z,:).*mnf(z)))/sum(norm(A(z,:)));
end 

% Set time-frequency plots.
figure
for i=1: Nmodes
    scatter(time(2:end-1),f_inst(i,:),5,A(i,:),'fill'); % a: Hilbert Aplitude / Energy Spectrum replace A(i,:) by A(i,:).^2
    tlabel;
    set(gca,'FontSize',8,'XLim',[time(2) time(end)],'YLim',[0 max(max(f_inst))]);
    colorbar;
    grid on;
    hold on
%     xlabel('Time');
    ylabel('Frequency (cpd)','FontSize',10);
    zlabel('Amplitude');
%     zlabel('Energy');
%     title('Hilbert Amplitude Spectrum','FontSize',12); 
    title('Hilbert Energy Spectrum','FontSize',12); 
ylim([0 3]) % changer cette ligne
end
% print -djpeg -r600 HilbertEnergySpectrum.jpeg

%% Spectre marginal de Hilbert versus spectre de Fourier

imf=imf1;               % Changer cette ligne si besoin
time=time_data(1,:);    % Changer cette ligne si besoin
data=series_data(1,:);  % Changer cette ligne si besoin


samplerate=1/dt;
hsp_fre1=3;
freqsol=400;
timesol=800;

% Hilbert-Spectrum
[nt,tscale,fscale]=nnspe(imf', time(1),time(end), freqsol, timesol, 0.00001, hsp_fre1,time(1),time(end),'hilbtm','spline',5);

% marginal spectrum
ms=sum(nt,2);
% Fourier spectrum
[Pxx,w] =pwelch(data,[],[],[],samplerate,'onesided');  


% Calculate  comparison coefficients ,and multiply to those spectrums
% comparison coefficients
hco=samplerate/2/hsp_fre1;
fco=2*samplerate*(length(imf))/2/freqsol;

% plot two different kind of spectrum together              
figure
loglog(w(1:end),fco*Pxx(1:end),'r',fscale(1:end),hco*ms(1:end),'b'); 

xlabel('Frequency (cycle per day)','fontsize',10,'FontWeight','bold','VerticalAlignment','middle')
ylabel('C^2_n(Marginal Spectrum)','fontsize',10,'FontWeight','bold');
legend('Fourier Power Spectrum','Marginal Hilbert Spectrum');
title('Marginal Hilbert Energy Spectrum versus Fourier Power Spectrum','fontsize',10,'FontWeight','bold')
grid on

% print -dbmp -r600 marginal_hilbert_spectrum.bmp


