function [m,v] = binostat(n,p)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:binostat:TooFewInputs');
validateattributes(n,{'numeric'},{'real'},'binostat','n',1); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'binostat','p',2); %#ok<EMCA>
m = coder.internal.sxalloc([isfloat(n),true],n,p);
v = coder.nullcopy(m);
for k = 1:numel(m)
    nk = eml_scalexp_subsref(n,k);
    pk = eml_scalexp_subsref(p,k);
    if pk >= 0 && pk <= 1 && nk >= 0 && floor(nk) == nk
        % Since nk could belong to integer class, cast it before using it.
        m(k) = cast(nk,class(m))*pk;
        v(k) = m(k)*(1 - pk);
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(m));
    end
end
