function y = evpdf(x,mu,sigma)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 1,'stats:evpdf:TooFewInputs');
if nargin < 2
    mu = zeros(class(x));
end
if nargin < 3
    sigma = ones(class(x));
end
validateattributes(x,{'single','double'},{'real'},'evpdf','x',1); %#ok<EMCA>
validateattributes(mu,{'single','double'},{'real'},'evpdf','mu',2); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'evpdf','sigma',3); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true],x,mu,sigma);
ZMAX = log(realmax(class(y)));
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    muk = eml_scalexp_subsref(mu,k);
    sigmak = eml_scalexp_subsref(sigma,k);
    if sigmak > 0
        zk = (xk - muk)/sigmak;
        if zk > ZMAX
            y(k) = 0;
        else
            y(k) = exp(zk - exp(zk))/sigmak;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end