function r = evrnd(mu,sigma,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:evrnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(mu,{'single','double'},{'real'},'evrnd','mu',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'evrnd','sigma',2); %#ok<EMCA>
r = coder.internal.sxalloc([true,true],mu,sigma,varargin{:});
r(:) = rand(size(r),class(r));
for k = 1:numel(r)
    sigmak = eml_scalexp_subsref(sigma,k);
    if sigmak >= 0
        muk = eml_scalexp_subsref(mu,k);
        r(k) = log(-log(r(k)))*sigmak + muk;
    else
        r(k) = coder.internal.nan(class(r));
    end
end
