function y = geopdf(x,p)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:geopdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'geopdf','x',1); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'geopdf','p',2); %#ok<EMCA>
y = coder.internal.sxalloc([isfloat(x),true],x,p);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    pk = eml_scalexp_subsref(p,k);
    if pk > 0 && pk <= 1 && ~isnan(xk)
        if xk >= 0 && xk == floor(xk)
            y(k) = pk*(1-pk)^cast(xk,class(y));
        else
            y(k) = 0;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
    