function y = gevpdf(x,k,sigma,mu)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:gevpdf:TooFewInputs');
if nargin < 2
    k = zeros(class(x));
end
if nargin < 3
    sigma = ones(class(x));
end
if nargin < 4
    mu = zeros(class(x));
end
validateattributes(x,{'single','double'},{'real'},'gevpdf','x',1); %#ok<EMCA>
validateattributes(k,{'single','double'},{'real'},'gevpdf','k',2); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gevpdf','sigma',3); %#ok<EMCA>
validateattributes(mu,{'single','double'},{'real'},'gevpdf','mu',4); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true,true],x,k,sigma,mu);
for j = 1:numel(y)
    xj = eml_scalexp_subsref(x,j);
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    muj = eml_scalexp_subsref(mu,j);
    if sigmaj > 0
        zj = (xj - muj)/sigmaj;
        if isinf(zj)
            y(j) = 0;
        elseif abs(kj) < eps(class(y))
            y(j) = exp(-exp(-zj) - zj)/sigmaj;
        else
            tj = zj*kj;
            if tj <= -1
                % 1 + k.*(x-mu)/sigma > 0 is the support,
                % force 0 outside that.
                y(j) = 0;
            else
                lg = log1p(tj);
                rk = 1/kj;
                y(j) = exp(-exp(-rk*lg) - (1 + rk)*lg)/sigmaj;
            end
        end
    else
        y(j) = coder.internal.nan(class(y));
    end
end
