function r = gevrnd(k,sigma,mu,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 3,'stats:gevrnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(k,{'single','double'},{'real'},'gevrnd','k',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gevrnd','sigma',2); %#ok<EMCA>
validateattributes(mu,{'single','double'},{'real'},'gevrnd','mu',3); %#ok<EMCA>
r = coder.internal.sxalloc([true,true,true],k,sigma,mu,varargin{:});
r(:) = rand(size(r),class(r));
for j = 1:numel(r)
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    muj = eml_scalexp_subsref(mu,j);
    if sigmaj >= 0
        if abs(kj) < eps(class(k))
            r(j) = muj - sigmaj*log(-log(r(j)));
        else
            r(j) = muj + sigmaj*expm1(-kj*log(-log(r(j))))/kj;
        end
    else
        r(j) = coder.internal.nan(class(r));
    end
end