function r = gprnd(k,sigma,theta,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 3,'stats:gprnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(k,{'single','double'},{'real'},'gprnd','k',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gprnd','sigma',2); %#ok<EMCA>
validateattributes(theta,{'single','double'},{'real'},'gprnd','theta',3); %#ok<EMCA>
r = coder.internal.sxalloc([true,true,true],k,sigma,theta,varargin{:});
r(:) = rand(size(r),class(r));
for j = 1:numel(r)
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    thetaj = eml_scalexp_subsref(theta,j);
    if sigmaj >= 0
        if abs(kj) < eps(class(k))
            r(j) = thetaj - sigmaj*log(r(j));
        else
            r(j) = thetaj + sigmaj*expm1(-kj*log(r(j)))/kj;
        end
    else
        r(j) = coder.internal.nan(class(r));
    end
end
