function x = hygeinv(p,m,k,n)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 4,'stats:hygeinv:TooFewInputs');
validateattributes(p,{'single','double'},{'real'},'hygeinv','p',1); %#ok<EMCA>
validateattributes(m,{'numeric'},{'real'},'hygeinv','m',2); %#ok<EMCA>
validateattributes(k,{'numeric'},{'real'},'hygeinv','k',3); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'hygeinv','n',4); %#ok<EMCA>
x = coder.internal.sxalloc([true,isfloat(m),isfloat(k),isfloat(n)],p,m,k,n);
for j = 1:numel(x)
    pj = eml_scalexp_subsref(p,j);
    mj = cast(eml_scalexp_subsref(m,j),class(x));
    kj = cast(eml_scalexp_subsref(k,j),class(x));
    nj = cast(eml_scalexp_subsref(n,j),class(x));
    if mj >= 0 && kj >= 0 && nj >= 0 && floor(mj) == mj && ...
            floor(kj) == kj && floor(nj) == nj && ...
            nj <= mj && kj <= mj && 0 <= pj && pj <= 1
        xj = zeros(class(x));
        cumdist = hygepdf(xj,mj,kj,nj);
        count = zeros(class(x));
        % Compare P to the hypergeometric distribution.
        while pj > cumdist && count < nj && count < kj
            count = count + 1;
            if cumdist < pj - eps(pj)
                xj = xj + 1;
                cumdist = cumdist + hygepdf(count,mj,kj,nj);
            end
        end
        % Check using hygecdf
        y = hygecdf(xj,mj,kj,nj);
        if y < pj
            while true
                xj = xj + 1;
                if ~(hygecdf(xj,mj,kj,nj) < pj)
                    break
                end
            end
        elseif y > pj
            while true
                if hygecdf(xj-1,mj,kj,nj) > pj
                    xj = xj - 1;
                else
                    break
                end
            end
        end
        x(j) = xj;
    else
        x(j) = coder.internal.nan(class(x));
    end
end
