function [m,v]= lognstat(mu,sigma)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:lognstat:TooFewInputs');
validateattributes(mu,{'single','double'},{'real'},'lognstat','mu',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'lognstat','sigma',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],mu,sigma);
v = coder.nullcopy(m);
for k = 1:numel(m)
    muk = eml_scalexp_subsref(mu,k);
    sigmak = eml_scalexp_subsref(sigma,k);
    if sigmak > 0 && ~isnan(muk)
        s2 = sigmak*sigmak;
        m(k) = exp(muk + 0.5*s2);
        v(k) = exp(2*muk + s2)*(exp(s2) - 1);
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
