function y = mad(x,flag,dim)
%MATLAB Code Generation Library Function

%   Limitations:
%   Does not permit empty dim input.

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 1,'MATLAB:minrhs');
if nargin < 2 || isempty(flag)
    DOMEDIAN = false;
else
    DOMEDIAN = logical(flag);
end
if nargin < 3
    dim = eml_const_nonsingleton_dim(x);
else
    coder.internal.prefer_const(dim);
    coder.internal.assert(eml_is_const(dim), ...
        'Coder:toolbox:dimNotConst');
    eml_assert_valid_dim(dim);
end
if isempty(x)
    y = sum(x,dim,'native'); % Should get size and type right.
    y(:) = coder.internal.nan(class(x));
elseif DOMEDIAN
    % Compute the median of the absolute deviations from the median.
    xm = nanmedian(x,dim);
    xx = abs(bsxfun(@minus,x,xm));
    y = nanmedian(xx,dim);
else
    % Compute the mean of the absolute deviations from the mean.
    xm = nanmean(x,dim);
    xx = abs(bsxfun(@minus,x,xm));
    y = nanmean(xx,dim);
end
