function sigma = moment(x,order,dim)
%MATLAB Code Generation Toolbox Function

%   Limitations:
%   Non-integral orders generally require that the data be complex.
%   If x is real, use moment(complex(x),order).

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 2,'stats:moment:TooFewInputs');
coder.internal.assert(isscalar(order),'stats:moment:BadOrder');
if eml_is_const(size(x)) && isequal(x,[])
    sigma = coder.internal.nan(class(x)) + eml_scalar_eg(x);
elseif nargin == 3
    coder.internal.prefer_const(dim);
    if order(1) == 1
        sz = size(x);
        if dim > numel(sz)
            sigma = zeros(sz,'like',x);
        else
            sz = size(x);
            sz(dim) = 1;
            sigma = zeros(sz,'like',x);
        end
    else
        x = bsxfun(@minus,x,mean(x,dim)).^order(1);
        sigma = mean(x,dim);
    end
else
    if order(1) == 1
        sz = size(mean(zeros(size(x))));
        sigma = zeros(sz,class(x));
    else
        x = bsxfun(@minus,x,mean(x)).^order(1);
        sigma = mean(x);
    end
end
