function [m,v] = nbinstat(r,p)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:nbinstat:TooFewInputs');
validateattributes(r,{'single','double'},{'real'},'nbinstat','r',1); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'nbinstat','p',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],r,p);
v = coder.nullcopy(m);
for k = 1:numel(m)
    rk = eml_scalexp_subsref(r,k);
    pk = eml_scalexp_subsref(p,k);
    if 0 < rk && isfinite(rk) && 0 < pk && pk <= 1
        m(k) = rk*(1-pk)/pk;
        v(k) = rk*(1-pk)/(pk*pk);
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end 
end

