function r = ncfrnd(nu1,nu2,delta,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 3,'stats:ncfrnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(nu1,{'numeric'},{'real'},'ncfrnd','nu2',1); %#ok<EMCA>
validateattributes(nu2,{'numeric'},{'real'},'ncfrnd','nu1',2); %#ok<EMCA>
validateattributes(delta,{'single','double'},{'real'},'ncfrnd','delta',3); %#ok<EMCA>
r = coder.internal.sxalloc([isfloat(nu1),isfloat(nu2),true],nu1,nu2,delta,varargin{:});
for k = 1:numel(r)
    nu1k = cast(eml_scalexp_subsref(nu1,k),class(r));
    nu2k = cast(eml_scalexp_subsref(nu2,k),class(r));
    deltak = eml_scalexp_subsref(delta,k);
    if nu1k > 0 && nu2k > 0 && deltak >= 0
        r1 = ncx2rnd(nu1k,deltak)/nu1k;
        r2 = 2*randg(nu2k/2)/nu2k;
        r(k) = r1/r2;
    else
        r(k) = coder.internal.nan(class(r));
    end
end
