function [m,v]= ncfstat(nu1,nu2,delta)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:ncfstat:TooFewInputs');
validateattributes(nu1,{'numeric'},{'real'},'ncfstat','nu1',1); %#ok<EMCA>
validateattributes(nu2,{'numeric'},{'real'},'ncfstat','nu1',2); %#ok<EMCA>
validateattributes(delta,{'single','double'},{'real'},'ncfstat','delta',3); %#ok<EMCA>
m = coder.internal.sxalloc([isfloat(nu1),isfloat(nu2),true],nu1,nu2,delta);
v = coder.nullcopy(m);
for k = 1:numel(m)
    nu1k = cast(eml_scalexp_subsref(nu1,k),class(m));
    nu2k = cast(eml_scalexp_subsref(nu2,k),class(m));
    deltak = eml_scalexp_subsref(delta,k);
    if nu2k > 2
        n1pd = nu1k + deltak;
        n2m2 = nu2k - 2;
        n2dn1 = nu2k/nu1k;
        m(k) = n2dn1*n1pd/n2m2;
        if nu2k > 4
            v(k) = 2*(n2dn1*n2dn1)*(n1pd*n1pd + (n1pd + deltak)*n2m2) / ...
                ((nu2k - 4)*(n2m2*n2m2));
        else
            v(k) = coder.internal.nan(class(v));
        end
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
