function [m,v]= nctstat(nu,delta)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:nctstat:TooFewInputs');
validateattributes(nu,{'numeric'},{'real'},'nctstat','nu',1); %#ok<EMCA>
validateattributes(delta,{'single','double'},{'real'},'nctstat','delta',2); %#ok<EMCA>
m = coder.internal.sxalloc([isfloat(nu),true],nu,delta);
v = coder.nullcopy(m);
for k = 1:numel(m)
    nk = cast(eml_scalexp_subsref(nu,k),class(m));
    dk = eml_scalexp_subsref(delta,k);
    if nk > 1
        nd2 = nk/2;
        nm1d2 = (nk - 1)/2;
        m(k) = dk*sqrt(nd2)*gamma(nm1d2)/gamma(nd2);
        if nk > 2
            dd = dk*dk;
            v(k) = nk/(nk - 2)*(1 + dd) - nd2*dd*exp(2*(gammaln(nm1d2) - gammaln(nd2)));
        else
            v(k) = coder.internal.nan(class(v));
        end
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end

