function y = normpdf(x,mu,sigma)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:normpdf:TooFewInputs');
if nargin < 2
    mu = zeros(class(x));
end
if nargin < 3
    sigma = ones(class(x));
end
validateattributes(x,{'single','double'},{'real'},'normpdf','x',1); %#ok<EMCA>
validateattributes(mu,{'single','double'},{'real'},'normpdf','mu',2); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'normpdf','sigma',3); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true],x,mu,sigma);
sqrt2pi = cast(sqrt(2*pi),class(y));
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    muk = eml_scalexp_subsref(mu,k);
    sigmak = eml_scalexp_subsref(sigma,k);
    if sigmak > 0
        t = (xk - muk)/sigmak;
        y(k) = exp(-0.5*t*t)/(sqrt2pi*sigmak);
    else
        y(k) = coder.internal.nan(class(y));
    end
end
