function [m,v]= normstat(mu,sigma)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:normstat:TooFewInputs');
validateattributes(mu,{'single','double'},{'real'},'normstat','mu',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'normstat','sigma',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],mu,sigma);
v = coder.nullcopy(m);
for k = 1:numel(m)
    muk = eml_scalexp_subsref(mu,k);
    sigmak = eml_scalexp_subsref(sigma,k);
    if sigmak > 0 && ~isnan(muk);
        m(k) = muk;
        v(k) = sigmak*sigmak;
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
