function y = pdf(name,x,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:pdf:TooFewInputs');
coder.internal.prefer_const(name);
coder.internal.assert(eml_is_const(name),'Coder:toolbox:InputMustBeConstant','NAME');
coder.internal.errorIf(~ischar(name),'stats:pdf:BadDistribution');
if nargin < 5
    c = 0;
else
    c = varargin{3};
end
if nargin < 4
    b = 0;
else
    b = varargin{2};
end
if nargin < 3
    a = 0;
else
    a = varargin{1};
end
if     strcmpi(name,'beta'),
    y = betapdf(x,a,b);
elseif strcmpi(name,'bino') || strcmpi(name,'Binomial'),
    y = binopdf(x,a,b);
elseif strcmpi(name,'chi2') || strcmpi(name,'Chisquare'),
    y = chi2pdf(x,a);
elseif strcmpi(name,'exp') || strcmpi(name,'Exponential'),
    y = exppdf(x,a);
elseif strcmpi(name,'ev') || strcmpi(name,'Extreme Value'),
    y = evpdf(x,a,b);
elseif strcmpi(name,'f'),
    y = fpdf(x,a,b);
elseif strcmpi(name,'gam') || strcmpi(name,'Gamma'),
    y = gampdf(x,a,b);
elseif strcmpi(name,'gev') || strcmpi(name,'Generalized Extreme Value'),
    y = gevpdf(x,a,b,c);
elseif strcmpi(name,'gp') || strcmpi(name,'Generalized Pareto'),
    y = gppdf(x,a,b,c);
elseif strcmpi(name,'geo') || strcmpi(name,'Geometric'),
    y = geopdf(x,a);
elseif strcmpi(name,'hyge') || strcmpi(name,'Hypergeometric'),
    y = hygepdf(x,a,b,c);
elseif strcmpi(name,'logn') || strcmpi(name,'Lognormal'),
    y = lognpdf(x,a,b);
elseif strcmpi(name,'nbin') || strcmpi(name,'Negative Binomial'),
    y = nbinpdf(x,a,b);
elseif strcmpi(name,'ncf') || strcmpi(name,'Noncentral F'),
    y = ncfpdf(x,a,b,c);
elseif strcmpi(name,'nct') || strcmpi(name,'Noncentral T'),
    y = nctpdf(x,a,b);
elseif strcmpi(name,'ncx2') || strcmpi(name,'Noncentral Chi-square'),
    coder.internal.errorIf(true,'Coder:toolbox:NotSupportedForCodegen', ...
        'Noncentral Chi-square');
    % y = ncx2pdf(x,a,b);
elseif strcmpi(name,'norm') || strcmpi(name,'Normal'),
    y = normpdf(x,a,b);
elseif strcmpi(name,'poiss') || strcmpi(name,'Poisson'),
    y = poisspdf(x,a);
elseif strcmpi(name,'rayl') || strcmpi(name,'Rayleigh'),
    y = raylpdf(x,a);
elseif strcmpi(name,'t'),
    y = tpdf(x,a);
elseif strcmpi(name,'unid') || strcmpi(name,'Discrete Uniform'),
    y = unidpdf(x,a);
elseif strcmpi(name,'unif')  || strcmpi(name,'Uniform'),
    y = unifpdf(x,a,b);
elseif strcmpi(name,'weib') || strcmpi(name,'Weibull') || strcmpi(name,'wbl')
    if strcmpi(name,'weib') || strcmpi(name,'Weibull')
        eml_warning('stats:pdf:ChangedParameters');
    end
    y = wblpdf(x,a,b);
else
    coder.internal.errorIf(true,'Coder:toolbox:NotSupportedForCodegen',name);
end
