function p = poisscdf(x,lambda,tail)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 2,'stats:poisscdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'poisscdf','x',1); %#ok<EMCA>
validateattributes(lambda,{'single','double'},{'real'},'poisscdf','lambda',2); %#ok<EMCA>
if nargin < 3
    upper = false;
else
    coder.internal.prefer_const(tail);
    upper = CheckForUpper(tail);
end
p = coder.internal.sxalloc([isfloat(x),true],x,lambda);
for k = 1:numel(p)
    xk = eml_scalexp_subsref(x,k);
    lambdak = eml_scalexp_subsref(lambda,k);
    if lambdak >= 0 && isfinite(lambdak) && isfinite(xk)
        xkf = cast(floor(xk),class(p));
        if xkf < 0
            p(k) = upper;
        else
            if upper
                p(k) = real(gammainc(lambdak,xkf+1,'lower'));
            else
                p(k) = real(gammainc(lambdak,xkf+1,'upper'));
            end
        end
    elseif xk > 0 && isinf(xk) && lambdak > 0 && isfinite(lambdak)
        p(k) = ~upper;
    else
        p(k) = coder.internal.nan(class(p));
    end
end
