function [upper,np] = CheckForUpper(varargin)
%MATLAB Code Generation Library Function

%   Examines the varargin list to see whether the last entry is 'upper' or
%   'lower'.  The second output NP is the number of parameters in varargin,
%   i.e., nargin-1 if 'upper' or 'lower' is supplied, otherwise, nargin.

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.inline('always');
coder.internal.prefer_const(varargin);
if nargin > 0 && ischar(varargin{end})
    upper = strcmpi(varargin{end},'upper');
    coder.internal.assert(upper || strcmpi(varargin{end},'lower'), ...
        'stats:cdf:UpperTailProblem', ...
        'IfNotConst','Fail');
    np = nargin - 1;
else
    upper = false;
    np = nargin;
end
