function bd0 = binodeviance(x,np)
%MATLAB Code Generation Private Function

%   Copyright 2010-2013 The MathWorks, Inc.
%#codegen
bd0 = coder.nullcopy(x);
for k = 1:numel(bd0)
    xk = x(k);
    npk = np(k);
    if abs(xk - npk) < 0.1*(xk + npk)
        % If "x/np" is close to 1:
        s = (xk - npk)*(xk - npk)/(xk + npk);
        v = (xk - npk)/(xk + npk);
        e = 2*xk*v;
        j = 1;
        vv = v*v;
        while true
            e = e*vv;
            j = j + 2;
            d = e/j;
            s = s + d;
            if abs(d) <= eps(s)
                break
            end
        end
        bd0(k) = s;
    else
        % If "x/np" is not close to 1:
        bd0(k) = xk*log(xk/npk) + npk - xk;
    end
end
