function x = raylinv(p,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:raylinv:TooFewInputs');
if nargin < 2
    b = ones(class(p));
end
validateattributes(p,{'single','double'},{'real'},'raylinv','p',1); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'raylinv','b',2); %#ok<EMCA>
x = coder.internal.sxalloc([true,true],p,b);
for k = 1:numel(x)
    pk = eml_scalexp_subsref(p,k);
    bk = eml_scalexp_subsref(b,k);
    if bk > 0 && 0 <= pk && pk <= 1
        if pk == 0
            x(k) = 0;
        elseif pk == 1
            x(k) = coder.internal.inf(class(x));
        else
            x(k) = sqrt((-2*(bk*bk))*log(1 - pk));
        end
    else
        x(k) = coder.internal.nan(class(x));
    end
end
