function y = raylpdf(x,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:raylpdf:TooFewInputs');
if nargin < 2
    b = ones(class(x));
end
validateattributes(x,{'single','double'},{'real'},'raylpdf','x',1); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'raylpdf','b',2); %#ok<EMCA>
y = coder.internal.sxalloc([true,true],x,b);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    bk = eml_scalexp_subsref(b,k);
    if bk > 0 && ~isnan(xk)
        if xk >= 0
            y(k) = (xk/(bk*bk))*exp(-xk*xk/(2*bk*bk));
        else
            y(k) = 0;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
