function y = tpdf(x,v)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:tpdf:TooFewInputs');
validateattributes(x,{'single','double'},{'real'},'tpdf','x',1); %#ok<EMCA>
validateattributes(v,{'numeric'},{'real'},'tpdf','v',2); %#ok<EMCA>
y = coder.internal.sxalloc([true,isfloat(v)],x,v);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    vk = eml_scalexp_subsref(v,k);
    if vk > 0
        if isinf(vk)
            y(k) = exp(-0.5*xk*xk)/sqrt(2*pi); % normpdf(xk,0,1)
        else
            vf = cast(vk,class(y));
            y(k) = exp(gammaln((vf + 1)/2) - gammaln(vf/2)) / ...
                (sqrt(vf*pi)*(1 + xk*xk/vf)^((vf + 1)/2));
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
