function x = unidinv(p,n)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2, ...
    'stats:unidinv:TooFewInputs');
validateattributes(p,{'single','double'},{'real'},'unidinv','p',1); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'unidinv','n',2); %#ok<EMCA>
x = coder.internal.sxalloc([true,isfloat(n)],p,n);
for k = 1:numel(x)
    pk = eml_scalexp_subsref(p,k);
    nk = eml_scalexp_subsref(n,k);
    if 0 < pk && pk <= 1 && nk >= 1 && floor(nk) == nk
        x(k) = ceil(cast(nk,class(x))*pk);
    else
        x(k) = coder.internal.nan(class(x));
    end
end
