function y = unidpdf(x,n)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2, ...
    'stats:unidpdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'unidpdf','x',1); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'unidpdf','n',2); %#ok<EMCA>
y = coder.internal.sxalloc([isfloat(x),isfloat(n)],x,n);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    nk = eml_scalexp_subsref(n,k);
    if nk >= 1 && nk == floor(nk)
        if xk >= 1 && xk <= nk && floor(xk) == xk
            y(k) = 1/cast(nk,class(y));
        else
            y(k) = 0;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
