function [m,v]= unidstat(n)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 1,'stats:unidstat:TooFewInputs');
validateattributes(n,{'numeric'},{'real'},'unidstat','n',1); %#ok<EMCA>
if isfloat(n)
    m = coder.nullcopy(n);
    v = coder.nullcopy(n);
else
    m = coder.nullcopy(zeros(size(n)));
    v = coder.nullcopy(zeros(size(n)));
end
for k = 1:numel(n)
    if n(k) > 0 && floor(n(k)) == n(k)
        nk = cast(n(k),class(m));
        m(k) = (nk + 1)/2;
        v(k) = (nk*nk - 1)/12;
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
