function x = unifinv(p,a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 1 || nargin == 3, ...
    'stats:unifinv:TooFewInputs');
if nargin < 3
    a = zeros(class(p));
    b = ones(class(p));
end
validateattributes(p,{'single','double'},{'real'},'unifinv','p',1); %#ok<EMCA>
validateattributes(a,{'single','double'},{'real'},'unifinv','a',2); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'unifinv','b',3); %#ok<EMCA>
x = coder.internal.sxalloc([true,true,true],p,a,b);
for k = 1:numel(x)
    pk = eml_scalexp_subsref(p,k);
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak < bk && 0 <= pk && pk <= 1
        x(k) = ak + pk*(bk - ak);
    else
        x(k) = coder.internal.nan(class(x));
    end
end
if nargin < 1,
    error(message('stats:unifinv:TooFewInputs'));
end
