function y = unifpdf(x,a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 1 || nargin == 3, ...
    'stats:unifpdf:TooFewInputs');
if nargin < 3
    a = zeros(class(x));
    b = ones(class(x));
end
validateattributes(x,{'single','double'},{'real'},'unifcdf','x',1); %#ok<EMCA>
validateattributes(a,{'single','double'},{'real'},'unifcdf','a',2); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'unifcdf','b',3); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true],x,a,b);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak < bk
        if xk >= ak && xk <= bk
            y(k) = 1/(bk - ak);
        else
            y(k) = 0;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
