function [m,v]= unifstat(a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:unifstat:TooFewInputs');
validateattributes(a,{'single','double'},{'real'},'unifstat','a',1); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'unifstat','b',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],a,b);
v = coder.nullcopy(m);
for k = 1:numel(m)
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak <= bk
        m(k) = (ak + bk)/2;
        v(k) = (bk - ak)*(bk - ak)/12;
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
