function y = wblpdf(x,A,B)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:wblpdf:TooFewInputs');
if nargin < 2
    A = ones(class(x));
end
if nargin < 3
    B = ones(class(x));
end
validateattributes(x,{'single','double'},{'real'},'wblpdf','x',1); %#ok<EMCA>
validateattributes(A,{'single','double'},{'real'},'wblpdf','A',2); %#ok<EMCA>
validateattributes(B,{'single','double'},{'real'},'wblpdf','B',3); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true],x,A,B);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    Ak = eml_scalexp_subsref(A,k);
    Bk = eml_scalexp_subsref(B,k);
    if Ak > 0 && Bk > 0
        if xk < 0
            y(k) = 0;
        else
            zk = xk/Ak;
            wk = exp(-(zk^Bk));
            if isnan(wk)
                y(k) = coder.internal.nan(class(y));
            elseif wk > 0
                y(k) = zk^(Bk - 1)*wk*Bk/Ak;
            else
                y(k) = 0;
            end
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end

