function [z,mu,sigma] = zscore(x,flag,dim)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 1,'MATLAB:minrhs');
if nargin < 2
    flag = 0;
end
if nargin < 3
    dim = eml_const_nonsingleton_dim(x);
else
    coder.internal.prefer_const(dim);
    coder.internal.assert(eml_is_const(dim), ...
        'Coder:toolbox:dimNotConst');
    eml_assert_valid_dim(dim);
end
% Compute X's mean and sd, and standardize it
mu = mean(x,dim);
sigma = std(x,flag,dim);
sigma0 = sigma;
for k = 1:numel(sigma0)
    if sigma0(k) == 0
        sigma0(k) = 1;
    end
end
z = bsxfun(@minus,x,mu);
z = bsxfun(@rdivide,z,sigma0);

