% Statistics Toolbox --- Demos
%
% Probability Distributions
%   copulademo   - Copula simulation demo.
%   disttool     - GUI tool for exploring probability distribution functions.
%   randtool     - GUI tool for generating random numbers.
%
% Fitting Distributions to Data.
%   cdffitdemo   - CDF fitting demo.
%   cfitdfitdemo - Curve fitting vs. distribution fitting demo.
%   customdist1demo - Custom distribution fitting demo.
%   customdist2demo - Custom distribution fitting demo 2.
%   gevdemo      - Generalized extreme value fitting demo.
%   gparetodemo  - Generalized Pareto fitting demo.
%   nonparametricCDFdemo - Nonparametric CDF and inverse demo.
%   survivaldemo - Survival data analysis demo.
%
% Multivariate Analysis.
%   classdemo    - Classification demo.
%   clusterdemo  - Cluster analysis demo.
%   cmdscaledemo - Classical multidimensional scaling demo.
%   creditratingdemo - Credit rating by bagging decision trees demo.
%   cvsequentialfsdemo - Feature selection and cross-validation demo.
%   factorandemo - Factor analysis demo.
%   mdscaledemo  - Non-classical multidimensional scaling demo.
%   mvplotdemo   - Multidimensional data plotting demo.
%   orthoregdemo - Orthogonal regression demo.
%
% Regression.
%   aoctool      - Interactive tool for analysis of covariance.
%   bayesdemo    - Bayesian analysis demo.
%   glmdemo      - Generalized linear model demo.
%   polytool     - Interactive graph for prediction of fitted polynomials.
%   robustdemo   - Interactive tool to compare robust and least squares fits.
%   rsmdemo      - Reaction simulation (DOE, RSM, nonlinear curve fitting).
%   stattsdemo   - Statistics on time series demo.
%   wnlsdemo     - Weighted nonlinear least squares demo.
%   plspcrdemo   - Partial least squares regression and principal components regression demo.
%   xform2lineardemo - Transforming nonlinear to linear demo.
%
% Hypothesis Testing.
%   samplesizedemo - Sample size calculation demo.
%
% Plotting.
%   fsurfht      - Interactive contour plot of a function.
%
% Utility Functions Used in Demos.
%   logn3fit     - 3-param lognormal fit function for cdffitdemo.
%   pcrsse       - SSE for principal components regression cross-validation in plspcrdemo.
%   wgtnormfit   - Weighted normal fit for customdist1demo.
%   wgtnormfit2  - Weighted normal fit based on log sigma for customdist1demo.
%
% See also STATS.

% Copyright 1993-2013 The MathWorks, Inc.

